INTERFACE Track;

(* Schnittstelle des abstrakten Datentyps Track.
   Autor           : Thomas von der Maen, RWTH Aachen
   Umgebung        : PM-3 Windows 2000
   Erstellt        : 19.12.00  Letzte Aenderung: 02.01.01 
*)

TYPE T <: REFANY;

PROCEDURE GetName(track: T): TEXT;
(* Liefert den Namen des Tracks *)

PROCEDURE SetName(VAR track: T; name: TEXT);
(* Setzt den Namen des Tracks auf den bergebenen String *)

PROCEDURE GetLength(track: T): CARDINAL;
(* Liefert die Lnge des Tracks in Sekunden *)

PROCEDURE SetLength(VAR track: T; length: CARDINAL);
(* Setzt die Lnge des bergebenen Tracks in Sekunden *)

PROCEDURE CreateTrack(): T;
(* Erstellt einen neuen Track und initialisiert diesen *)

END Track.