MODULE Track;

(* Modul zur Klasse Track
   Autor           : Antje Nowack, Thomas van der Massen
   Umgebung  : PM-3 Windows 95
   Erstellt        : 19.12.00  Letzte Aenderung: 22.01.01 
*)

IMPORT SIO;

REVEAL  
   T = Public BRANDED OBJECT
              name: TEXT;
              length: CARDINAL;
            OVERRIDES
              GetName := GetNameTrack;
                (* Liefert den Namen des Tracks *)
               SetName := SetNameTrack;
               (* Setzt den Namen des Tracks auf den bergebenen String *)
               GetLength := GetLengthTrack;
                (* Liefert die Lnge des Tracks in Sekunden *)
               SetLength := SetLengthTrack;
               (* Setzt die Lnge des bergebenen Tracks in Sekunden *)
               Print := PrintTrack;

    END;


PROCEDURE GetNameTrack(self: T): TEXT =
(* Liefert den Namen des Tracks *)
BEGIN
  RETURN self.name;
END GetNameTrack;


PROCEDURE SetNameTrack(self: T; n: TEXT) =
(* Setzt den Namen des Tracks auf den bergebenen String *)
BEGIN
  self.name := n;
END SetNameTrack;


PROCEDURE GetLengthTrack(self: T): CARDINAL =
(* Liefert die Lnge des Tracks in Sekunden *)
BEGIN
  RETURN (self.length);
END GetLengthTrack;


PROCEDURE SetLengthTrack(self: T; l: CARDINAL) =
(* Setzt die Lnge des bergebenen Tracks in Sekunden *)
BEGIN
  self.length := l;
END SetLengthTrack;

PROCEDURE PrintTrack(self : T)  =
BEGIN 
  SIO.PutText("Titel: " & self.name & " Laenge: ");
  SIO.PutInt(self.length);
END PrintTrack; 

BEGIN
END Track.
