;; Loesung zu Aufgabe 12.2 a)

;; Hilfsfunktion

(defun quadrat (x)
    (* x x) )


;; berechnet die Wurzel von a

(defun wurzel (a)

    ; ermittelt die Wurzel der Zahl a durch Probieren von 1 aufwaerts
    (defun ermittleWurzel (a zaehler)
        (cond ((< (quadrat zaehler) a) (ermittleWurzel a (+ zaehler 1)))
              ((= (quadrat zaehler) a) zaehler)
              (T 0)) )

    ; starte Probe mit 1
    (ermittleWurzel a 1))


;; Loesung zu Aufgabe 12.2 b)
;; die Wurzelfunktion aus Teil a) wird dabei verwendet

;; Hilfsfunktion, berechnet die Summe der Quadrate von x und y

(defun quadratsumme (x y)
    (+ (quadrat x) (quadrat y)))


;; ermittelt durch Probieren aller (u, v)-Kombinationen im Wertebereich
;; (a..b) eine passende Zahl w und gibt bei Erfolg das pythagoraeische
;; Tripel (u, v, w), andernfalls NIL zurueck

(defun pythagoras_tripel (a b)

    ;; Hilfsfunktion, probiert alle Kombinationen von (u, v)
    (defun probiere (u v)
        (cond ((= (wurzel (quadratsumme u v)) 0)
               ; Tripel noch nicht gefunden
               (cond ((and (= u b) (= v b)) ()) ;leere Liste zurueckgeben
                     ((and (< u b) (= v b)) (probiere (+ u 1) a))
                     ((< v b)               (probiere u (+ v 1)))))
                
               ; passendes Tripel gefunden, als Liste zurueckgeben
              (T (list u v (wurzel (quadratsumme u v))))) )

    ; starte Probe mit u = a und v = a
    (probiere a a))