studentHoertVorlesung(balin, kryptographie).
studentHoertVorlesung(beutlin, compilerbau).
studentHoertVorlesung(boffin, softwaretechnik).
studentHoertVorlesung(brandybock, mustererkennung).
studentHoertVorlesung(pausbacken, mustererkennung).
studentHoertVorlesung(straffguertel, compilerbau).
studentHoertVorlesung(bolger, datenkommunikation).
studentHoertVorlesung(honblaeser, softwaretechnik).
studentHoertVorlesung(stolzfuss, datenkommunikation).

profLiestVorlesung(hromkovic, kryptographie).
profLiestVorlesung(indermark, compilerbau).
profLiestVorlesung(nagl, softwaretechnik).
profLiestVorlesung(spaniol, datenkommunikation).
profLiestVorlesung(ney, mustererkennung).


balin_hoert_bei_hromkovic :- studentHoertVorlesung(balin, kryptographie),
                             profLiestVorlesung(hromkovic, kryptographie).
student_hoert_bei_nagl(Student) :- studentHoertVorlesung(Student, softwaretechnik),
                                   profLiestVorlesung(nagl, softwaretechnik).
student_hoert_bei(Student, Prof) :- studentHoertVorlesung(Student, Vorlesung),
                                    profLiestVorlesung(Prof, Vorlesung).
beutlin_ist_kommilitoneVon_balin :- studentHoertVorlesung(beutlin, Vorlesung),
                                    studentHoertVorlesung(balin, Vorlesung).
kommilitoneVon(Stud1, Stud2) :- studentHoertVorlesung(Stud1, Vorlesung),
                                studentHoertVorlesung(Stud2, Vorlesung),
                                not(Stud1=Stud2).
                               
                                
