MODULE Fib EXPORTS Main;

(* Autor: Antje Nowack
   Umgebung: PM3, Windows95
   Erstellt: 22. 11. 2000
   Letzte Aenderung: 22. 11. 2000
*)


IMPORT SIO;

PROCEDURE Fib (a,b, n : CARDINAL ) : CARDINAL =

(* a, b sind die zu uebergebenden Parameter, n ... *)

VAR first, second, result, number: CARDINAL;

(* first gibt das erste Argument auf Stufe number , second das zweite,
result haelt das Ergebnis auf der aktuellen Iterationsstufe *)

  BEGIN
    IF n = 0 THEN RETURN a;
    ELSIF n = 1 THEN RETURN b;
    ELSE

(* Initialisierung von first, second, number *)
      first := a;
      second := b;
      number := 2;

(* Der folgende Teil des Programms wird mehrmals durchlaufen *)
(* In der Schleife wird number pro Durchlauf um 1 erhoeht, first, second,
result entsprechend aktualisiert. Wenn number die Zahl n erreicht, wird der
Schleifendurchlauf beendet. *)

      WHILE number <= n DO
        result := b * first + a * second;
        first := second;
        second := result;
        number := number + 1;
      END;
      RETURN result;
    END;
  END Fib;



BEGIN
  SIO.PutText("Bitte geben Sie in dieser Reihenfolge a, b, n ein:");
  SIO.PutInt(Fib(SIO.GetInt(),SIO.GetInt(),SIO.GetInt()));
  SIO.Nl();

END Fib.