MODULE Stelligkeit_v1 EXPORTS Main;
(* Dieses Programm berechnet die Stelligkeit von Zahlen
   Autor    : Horst Lichter
   Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
   Erstellt : 24.08.98   
   Letzte Aenderung: 24.08.98
*)

IMPORT SIO;
VAR wert : INTEGER;

PROCEDURE IstEinstellig ( i : INTEGER) : BOOLEAN =
BEGIN
  RETURN ( (i>0) AND (i<10) );
END IstEinstellig;

PROCEDURE IstZweistellig ( i : INTEGER) : BOOLEAN =
BEGIN
  RETURN ( (i>=10) AND (i<100) );
END IstZweistellig;

PROCEDURE IstDreistellig ( i : INTEGER) : BOOLEAN =
BEGIN
  RETURN ( (i>=100) AND (i<1000) );
END IstDreistellig;

PROCEDURE IstMinVierstellig ( i : INTEGER) : BOOLEAN =
BEGIN
  RETURN ( (i>=1000) );
END IstMinVierstellig;

PROCEDURE ErmittleStelligkeit_1(i : INTEGER) : TEXT =
BEGIN
  SIO.PutLine ("ErmittleStelligkeit_1");
  IF IstEinstellig(i)     THEN RETURN ("einstellig")  END;
  IF IstZweistellig(i)    THEN RETURN ("zweistellig") END;
  IF IstDreistellig(i)    THEN RETURN ("dreistellig") END;
  IF IstMinVierstellig(i) THEN RETURN ("mindestens vierstellig")
  ELSE                         RETURN ("negativ")
  END;
END ErmittleStelligkeit_1;

PROCEDURE ErmittleStelligkeit_2(i : INTEGER) : TEXT =
BEGIN
  SIO.PutLine ("ErmittleStelligkeit_2");
  IF IstEinstellig(i)        THEN RETURN ("einstellig")
  ELSIF IstZweistellig(i)    THEN RETURN ("zweistellig")
  ELSIF IstDreistellig(i)    THEN RETURN ("dreistellig")
  ELSIF IstMinVierstellig(i) THEN RETURN ("mindestens vierstellig")
  ELSE                            RETURN ("negativ")
  END;
END ErmittleStelligkeit_2;

 
BEGIN
  wert := SIO.GetInt();
  SIO.PutText(ErmittleStelligkeit_1(wert)); SIO.Nl();
  SIO.PutText(ErmittleStelligkeit_2(wert)); SIO.Nl();
END Stelligkeit_v1.