MODULE Hanoi EXPORTS Main;
(* Ausgabe der Zugfolge fuer Tuerme von Hanoi
   Autor    : Horst Lichter
   Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
   Erstellt : 24.08.98   
   Letzte Aenderung: 25.08.98   
*)

IMPORT SIO;

PROCEDURE DruckeZug (hoehe: CARDINAL; von, nach : TEXT)  =
(* Diese Funktion wird von BewegeTurm aufgerufen um die Ergebnisse 
   dieser Funktion auszugeben *)
BEGIN
  SIO.PutText ("Scheibe "); SIO.PutInt (hoehe);
  SIO.PutText (" von " & von & " nach " & nach);
  SIO.Nl();
END DruckeZug ;

PROCEDURE BewegeTurm ( hoehe : CARDINAL; von, nach, ueber: TEXT)  =
(* Berechnet die ntigen Zge zur Lsung des "Hanoi-Problems" *)
BEGIN
  IF hoehe > 0 THEN			    (* Abbruchbedingung d. Rekusion *)
    BewegeTurm (hoehe-1, von, ueber, nach); (* Solange hoehe > 0 luft die Rekursion weiter *)
    DruckeZug  (hoehe, von, nach);          (* Hier wird der Zug ausgegeben *)
    BewegeTurm (hoehe-1, ueber, nach, von);
  END;
END BewegeTurm;

 
BEGIN
  BewegeTurm(SIO.GetInt(), "ALPHA", "OMEGA", "DELTA" );
END Hanoi.