MODULE Point_Test EXPORTS Main;

(* Implementierung der Point0 Klasse.
Autor : Horst Lichter, RWTH Aachen
Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
Erstellt : 16.08.98
Letzte Aenderung: 09.01.2001
*)

TYPE Point = OBJECT
                x : INTEGER;
                y : INTEGER;
             METHODS
                getX(): INTEGER          := GetX;
                setX (value : INTEGER)   := SetX;
                getY (): INTEGER         := GetY;
                setY (value : INTEGER)   := SetY;
                add (p: Point) : Point   := Add;
                minus (p : Point) : Point:= Minus;
             END;  

PROCEDURE GetX(self : Point): INTEGER =
BEGIN
  RETURN self.x;
END GetX;

PROCEDURE GetY(self : Point): INTEGER =
BEGIN
  RETURN self.y;
END GetY;

PROCEDURE SetX(self: Point; value : INTEGER) =
BEGIN
  self.x := value;
END SetX;

PROCEDURE SetY(self: Point; value : INTEGER) =
BEGIN
  self.y := value;
END SetY;

PROCEDURE Add (self: Point; p: Point) : Point =
VAR newP : Point;
BEGIN
  newP := NEW(Point);
  newP.setX(self.x + p.getX());
  newP.setY(self.y + p.getY());
  RETURN newP;
END Add;

PROCEDURE Minus (self: Point; p: Point) : Point =
VAR newP : Point;
BEGIN
  newP := NEW(Point);
  newP.setX(self.x - p.getX());
  newP.setY(self.y - p.getY());
  RETURN newP;
END Minus;

VAR p1, p2, p3 : Point;
BEGIN
  p1 := NEW(Point);
  p1.setX(10);
  p1.setY(10);
  p2 := NEW(Point);
  p2.setX(20);
  p2.setY(20);
  p3 := p1.add(p2);
END Point_Test.