/* sortiert ist wahr, wenn die uebergebene Zahlenliste aufsteigend sortiert ist. */

/* Die leere Liste ist sortiert. */



sortiert([]).



/* Ein Liste mit nur einem Element ist sortiert. */



sortiert([E]).



/* Eine Liste mit mehr als einem Element ist sortiert, wenn das erste Element kleiner-gleichist als das zweite */

/* Element und die Restliste sortiert ist */



sortiert([E1, E2|L]) :- E1 =< E2, sortiert([E2|L]).





/* permutation(X,Y)  ist wahr, wenn Y eine Permutation von X ist, wobei X und Y Listen sind. */

/* Fuer die leere Liste gibt es nur eine Permutation ... */



permutation([], []).



/* .... bei mehr als einem Element gilt permutation(X,Y), wenn auch permutation(X', Y') gilt, wobei */

/* X' aus X entsteht, indem das erste Vorkommen des ersten Elementes aus X gestrichen werden und */

/* Y aus Y' durch Streichen des ersten Vorkommen des ersten Elementes aus X gestrichen wird. */



permutation(Liste1, [E2|Rest2]) :- streiche(E2, Liste1, Rest1), permutation(Rest1, Rest2).





/* streiche(E, L1, L2) ist wahr, wenn L1 aus L2 durch Streichen des ersten Vorkommens von E entsteht. */



streiche(E, [E|Rest], Rest).



streiche(E, [A|Rest], [A|RestohneE]) :- streiche(E, Rest, RestohneE).





/* sortiere(L1, L2)  ist wahr, wenn L2 sortiert ist und L2 eine Permutation von L1 ist */



sortiere(UL,SL) :- permutation(UL, SL), sortiert(SL).