MODULE Ordner_Test1 EXPORTS Main;


IMPORT OrdnerADT,  SIO;
VAR 
   ordner1, ordner2 : OrdnerADT.Ordner;

CONST Max = 20;
TYPE Index = [1 .. Max];
TYPE Elemente = ARRAY Index OF TEXT;

     Behaelter = REF RECORD
                   inhalt  : Elemente;
                   anzahl  : CARDINAL;
                   kennung : TEXT := "";
                 END;

VAR behaelter1, behaelter2 : Behaelter;


BEGIN
  
  ordner1 := OrdnerADT.Anlegen();
  OrdnerADT.Beschrifte (ordner1, "Kleine Gedichte");
  OrdnerADT.LegeTextAb (ordner1, "Nicht immer sind bequeme Stuehle ...");

  ordner2 := OrdnerADT.Anlegen();
  OrdnerADT.Beschrifte (ordner2, "Kleine Gedichte");
  OrdnerADT.LegeTextAb (ordner2, "Nicht immer sind bequeme Stuehle ...");

  IF ordner1 = ordner2 THEN
    SIO.PutLine ("1 ordner sind gleich");
  ELSE
    ordner2 := ordner1;
    OrdnerADT.Beschrifte (ordner1, "Romane");
  END;
  IF ordner1 = ordner2 THEN
    SIO.PutLine ("nach Zuweisung sind die Ordner  gleich");
  END;

  SIO.PutLine (OrdnerADT.GibBeschriftung(ordner1));
  SIO.PutLine ("---------------------------");
  SIO.PutLine (OrdnerADT.GibBeschriftung(ordner2));
  
  behaelter1 := NEW(Behaelter);
  behaelter1^.anzahl := 1;
  behaelter1^.inhalt[1] := "Das ist ein Behaelter";

  (* ordner1 := behaelter1;*)


END Ordner_Test1.